org.keycloak.authorization.store

## Interface StoreFactory

- All Superinterfaces:
    Provider
  All Known Subinterfaces:
    CachedStoreFactoryProvider
  All Known Implementing Classes:
    JPAStoreFactory, StoreFactoryCacheSession

      public interface StoreFactory
      extends Provider

  A factory for the different types of storages that manage the persistence of the domain model types.

  Implementations of this interface are usually related with the creation of those storage types accordingly with a specific persistence mechanism such as relational and NoSQL databases, filesystem, etc.

  Author:
    Pedro Igor

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `PermissionTicketStore` | `getPermissionTicketStore()` Returns a `PermissionTicketStore`.
    `PolicyStore` | `getPolicyStore()` Returns a `PolicyStore`.
    `ResourceServerStore` | `getResourceServerStore()` Returns a `ResourceServerStore`.
    `ResourceStore` | `getResourceStore()` Returns a `ResourceStore`.
    `ScopeStore` | `getScopeStore()` Returns a `ScopeStore`.
    `boolean` | `isReadOnly()` Indicates if instances returned from storage are read-only.
    `void` | `setReadOnly(boolean readOnly)` Sets whether or not changes to instances returned from this factory are supported.

    - ### Methods inherited from interface org.keycloak.provider.Provider

      `close`

- - ### Method Detail

    - #### getResourceStore

          ResourceStore getResourceStore()

      Returns a `ResourceStore`.
      Returns:
        the resource store

    - #### getResourceServerStore

          ResourceServerStore getResourceServerStore()

      Returns a `ResourceServerStore`.
      Returns:
        the resource server store

    - #### getScopeStore

          ScopeStore getScopeStore()

      Returns a `ScopeStore`.
      Returns:
        the scope store

    - #### getPolicyStore

          PolicyStore getPolicyStore()

      Returns a `PolicyStore`.
      Returns:
        the policy store

    - #### getPermissionTicketStore

          PermissionTicketStore getPermissionTicketStore()

      Returns a `PermissionTicketStore`.
      Returns:
        the permission ticket store

    - #### setReadOnly

          void setReadOnly(boolean readOnly)

      Sets whether or not changes to instances returned from this factory are supported. Once marked as read-only, any attempt to change state will throw an `IllegalStateException`.
      Parameters:
        `readOnly` - if true, changes are not supported

    - #### isReadOnly

          boolean isReadOnly()

      Indicates if instances returned from storage are read-only.
      Returns:
        if true, instances only support reads.

Copyright © 2020 JBoss by Red Hat. All rights reserved.